/*******************************************************************************
* Copyright (C) 2017 CEESAR, FITT, INRIA, UCBL-Ifsttar                         *
* This file is part of the PIPER Framework.                                    *
* Version: 1.0.0                                                               *
*                                                                              *
* The PIPER Framework is free software: you can redistribute it and/or modify  *
* it under the terms of the GNU General Public License as published by the     *
* Free Software Foundation, either version 2 of the License, or (at your       *
* option) any later version.                                                   *
*                                                                              *
* The PIPER Framework is distributed in the hope that it will be useful, but   *
* WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY   *
* or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License     *
* for more details. You should have received a copy of the GNU General Public  *
* License along with the PIPER Framework.                                      *
* If not, see <http://www.gnu.org/licenses/>.                                  *
*                                                                              *
* Contributors include Erwan Jolivet (CEESAR); Aditya Chhabra, Sachiv          *
* Paruchuri, Dhruv Kaushik, Sukhraj Singh, Kshitij Mishra, Anoop Chawla        *
* (FITT); Thomas Lemaire (INRIA); Tomas Janak, Thomas Dupeux, Matthieu Mear    *
* (UCBL-Ifsttar)                                                               *
*                                                                              *
* This work has received funding from the European Union Seventh Framework     *
* Program ([FP7/2007-2013]) under grant agreement 605544 [PIPER project]).     *
*                                                                              *
*******************************************************************************/
#ifndef QVTKFrameBufferObjectItem_h_
#define QVTKFrameBufferObjectItem_h_


#ifdef WIN32
#	ifdef pipercommon_EXPORTS
#		define PIPERCOMMON_EXPORT __declspec( dllexport )
#	else
#		define PIPERCOMMON_EXPORT __declspec( dllimport )
#	endif
#else
#	define PIPERCOMMON_EXPORT
#endif

#include <vtkEventQtSlotConnect.h>
#include <vtkSmartPointer.h>
#include <vtkGenericOpenGLRenderWindow.h>
#include <vtkHardwareSelector.h>
#include <vtkRenderer.h>

#include <QtQuick/QQuickFramebufferObject>
// Use the OpenGL API abstraction from Qt instead of from VTK because vtkgl.h
// and other Qt OpenGL-related headers do not play nice when included in the
// same compilation unit
#include <QOpenGLFunctions>

#include <qqmlapplicationengine.h>

class QVTKFramebufferObjectRenderer;
class QVTKInteractorAdapter;
class vtkInternalOpenGLRenderWindow;
class QVTKFramebufferObjectRenderer;

/// <summary>
/// This class serves as an interface between VTK and Qt for the rendering purposes. Through an instance of this class,
/// Qt creates a Qt renderer (which works within the Qt's rendering thread), which in turn provides an actual framebuffer - a texture - to which
/// external (non-Qt, in our case VTK) classes can render their content.
/// QVTKFrameBufferObjectItem mainly handles "translation" of signals generated by VTK classes to Qt slots. The callback functions of these signals mainly
/// make sure that all rendering is done with the open-GL context properly initialized and within the Qt's rendering thread.
/// </summary>
/// <seealso cref="QQuickFramebufferObject" />
class PIPERCOMMON_EXPORT QVTKFrameBufferObjectItem : public QQuickFramebufferObject
{
    Q_OBJECT

public:
//    static QQmlApplicationEngine* qmlEngine;
    QVTKFrameBufferObjectItem(QQuickItem *parent = 0);
    ~QVTKFrameBufferObjectItem();
    Renderer *createRenderer() const;
    vtkSmartPointer<vtkInternalOpenGLRenderWindow> GetRenderWindow() const;

protected:
    // Called once before the FBO is created for the first time. This method is
    // called from render thread while the GUI thread is blocked.
    virtual void init();

    vtkSmartPointer<vtkInternalOpenGLRenderWindow> m_win;
    QVTKInteractorAdapter* m_irenAdapter;
    vtkSmartPointer<vtkEventQtSlotConnect> mConnect;

    friend class QVTKFramebufferObjectRenderer;

    // Convert the position of the event from openGL coordinate to native coordinate
    QMouseEvent openGLToNative(QMouseEvent const& event);

    virtual void mouseMoveEvent(QMouseEvent * event);
    virtual void mousePressEvent(QMouseEvent * event);
    virtual void mouseReleaseEvent(QMouseEvent * event);
    virtual void mouseDoubleClickEvent(QMouseEvent * event);
    virtual void wheelEvent(QWheelEvent *event);
    virtual void keyPressEvent(QKeyEvent* event);
    virtual void keyReleaseEvent(QKeyEvent* event);
    virtual void focusInEvent(QFocusEvent * event);
    virtual void focusOutEvent(QFocusEvent * event);


    protected Q_SLOTS:
    // slot to make this vtk render window current
    virtual void MakeCurrent();
    // slot called when vtk wants to know if the context is current
    virtual void IsCurrent(vtkObject* caller, unsigned long vtk_event, void* client_data, void* call_data);
    // slot called when vtk wants to start the render
    virtual void Start();
    // slot called when vtk wants to end the render
    virtual void End();
    // slot called when vtk wants to know if a window is direct
    virtual void IsDirect(vtkObject* caller, unsigned long vtk_event, void* client_data, void* call_data);
    // slot called when vtk wants to know if a window supports OpenGL
    virtual void SupportsOpenGL(vtkObject* caller, unsigned long vtk_event, void* client_data, void* call_data);
};

/// <summary>
/// An extension of vktGenericOpenGLRenderWindow to work with Qt.
/// Serves to write VTK-generated render calls to a framebuffer provided and maintained by Qt. It is meant to be used within Qt render loop, i.e. using Qt's render thread.
/// </summary>
/// <seealso cref="vtkGenericOpenGLRenderWindow" />
/// <seealso cref="QOpenGLFunctions" />
class vtkInternalOpenGLRenderWindow : public vtkGenericOpenGLRenderWindow, protected QOpenGLFunctions
{

public:
    static vtkInternalOpenGLRenderWindow* New();
    vtkTypeMacro(vtkInternalOpenGLRenderWindow, vtkGenericOpenGLRenderWindow)

    virtual void OpenGLInitState();

    // Override to use deferred rendering - Tell the QSG that we need to
    // be rendered which will then, at the appropriate time, call
    // InternalRender to do the actual OpenGL rendering.
    virtual void Render();

    // Do the actual OpenGL rendering
    void InternalRender();
    
    /// <summary>
    /// Stores a reference for a special renderer that will be used for the picking rendering pass and adds it to the active renderers collection of the renderwindow.
    /// Only actors in this renderer will be available for picking.
    /// </summary>
    /// <param name="renderer">The renderer.</param>
    void SetPickingRenderer(vtkSmartPointer<vtkRenderer> renderer);

    /// <summary>
    /// Gets the picking renderer.
    /// WARNING - If you want to add or remove objects rendered by this renderer, make sure you are doing it from within the main thread - when IsRenderingBlocked() is false.
    /// </summary>
    /// <returns>A renderer that the renderWindow does not use for visualization, but only for picking - i.e. only actors in this renderer are pickable,
    /// but to visualize them you have to also add them to the default renderer.</returns>
    vtkSmartPointer<vtkRenderer> GetPickingRenderer() { return this->pickingRenderer; }

    /// <summary>
    /// Stores a reference for the default renderer meant to draw every visible prop and adds it to the active renderers collection of the renderwindow.
    /// </summary>
    /// <param name="renderer">The renderer.</param>
    void SetDefaultRenderer(vtkSmartPointer<vtkRenderer> renderer);

    /// <summary>
    /// Gets the default renderer.
    /// WARNING - If you want to add or remove objects rendered by this renderer, make sure you are doing it from within the main thread - when IsRenderingBlocked() is false.
    /// </summary>
    /// <returns>Renderer containing all actors that should be visible on the screen.</returns>
    vtkSmartPointer<vtkRenderer> GetDefaultRenderer() { return this->defaultRenderer; }
    
    /// <summary>
    /// Adds the render to the window and sets it as "default".
    /// Consider using SetDefaultRenderer and SetNonPickablesRenderer instead.
    /// </summary>
    /// <param name="renderer">The renderer.</param>
    virtual void AddRenderer(vtkRenderer *renderer);

    // Provides a convenient way to set the protected FBO ivars from an existing
    // FBO that was created and owned by Qt's FBO abstraction class
    // QOpenGLFramebufferObject
    void SetFramebufferObject(QOpenGLFramebufferObject *fbo);

    void BlockRendering(bool val) {
        this->blockRendering = val;
    }

    bool IsRenderingBlocked() {
        return blockRendering;
    }

    QVTKFramebufferObjectRenderer *QtParentRenderer;

    bool hasTransparentObjects = false;
    vtkSmartPointer<vtkHardwareSelector> scenePicker;
    bool scenePickerUpToDate = false;
    bool blockScenePicker = true; // if true, rendering pass for the ScenePicker is not performed
protected:

    bool blockRendering = false; // if true, no rendering is done at all
    bool pickerRenderPass = false;
    vtkSmartPointer<vtkRenderer> defaultRenderer = NULL;
    vtkSmartPointer<vtkRenderer> pickingRenderer = NULL;

    vtkInternalOpenGLRenderWindow(); 

    ~vtkInternalOpenGLRenderWindow()
    {
        // Prevent superclass destructors from destroying the framebuffer object.
        // QOpenGLFramebufferObject owns the FBO and manages it's lifecyle.
        this->OffScreenRendering = 0;
    }
};

#endif
